#ifndef _PWglobal_var_
#define _PWglobal_var_

#include "sis.h"
#include "PWilib.h"

extern char*			PWdeviceName[];
extern LOGIC_VALUE		ctrlValue[];
extern LOGIC_VALUE		inversion[];
extern int				PWoptTable[4][4][4];
extern int				PWMuxTable[4][4][4];

extern long 			PWlineNum;
extern long 			PWinstNum;
extern long 			PWinstNum_and_pseudo;
extern long 			PrimInNum,PrimOutNum;
extern long 			DF_Num;
extern long				vdd_index,gnd_index;

extern long				PSEUDO_PI_index, PSEUDO_PO_index;
extern int				pseudoCount;

extern PW_INST 			* instList;
extern PW_INST 			* unknownCellList;
extern PW_INST 			* DFlipList;

extern PW_INST 			* SourceP[MAX_PI], * SinkP[MAX_PO];

extern PW_INST 			* LevList;

extern PW_BUCKET   		*PWbucketList;
extern PW_BUCKET   		*PWbucketTail;
extern int         		maxGainIndex;

extern long    			sortedInstNum;
extern PW_INST 			** instSortedList;

extern FILE    		 	*dbgFp;
extern FILE  		 	*resultFp;

extern lin_table_rec 	MFFClistHead,MFFClistTail;
extern lin_table_rec 	MFFCrootList;
extern lin_table_rec 	nonMFFCrootList;
extern int           	gainShiftAmount;
extern int           	numberofMFFC;
extern BOOLEAN       	MFFC_Id[MAX_NUM_MFFC];

extern ilib_table_t 	*PWilib_table;

#endif
