#ifndef _PW_MEM_COPY_SIS_
#define _PW_MEM_COPY_SIS_

#include "PWcir.h"

extern int PWmemcpy_sis(network_t *network);
extern int InstMemCopy(network_t *network);
extern int CktConnectCopy(network_t *network);
extern int GateMemCopy(network_t *network);
extern int memCopyOneGate(node_t *node);

extern void xlink_imaxup_sis_node(PW_INST *inst, node_t *node);

extern void xlink_imaxup_sis_latch(PW_INST *inst, latch_t *latch);

extern int sis_node_func_AND_type(node_t *node);
extern int sis_node_func_OR_type(node_t *node);
extern int sis_node_func_complex_type(node_t *node);

extern int LatchMemCopy(network_t *network);
extern int PO_MemCopy(network_t *network);
extern int PI_MemCopy(network_t *network);
extern int PPI_MemCopy(network_t *network);

extern BOOLEAN isPPI_node(node_t *node, network_t *network);
extern int FormPIPOlist(network_t *network);

#endif
