/*
		FILE:  PWcommand.c
		DESCR: Command init/end for imax_powerup
		AUTH:  Fei Li
		DATE:  Nov. 2001
*/

#include "sis.h"

extern int imax_powerup_command(network_t **network, int argc, char **argv);
extern int leakage_command(network_t **network, int argc, char **argv);

extern void init_imax_powerup(void);
extern void end_imax_powerup(void);

void
init_imax_powerup(void)
{
	com_add_command("imaxup", imax_powerup_command, 1);
	com_add_command("lkg", leakage_command, 1);
}

void
end_imax_powerup(void)
{}
