BEGIN{
	ind1 = 0 ;
	ind2 = 0 ;
	total_error = 0;
	total_current = 0 ;
	lest_current = 2000 ;
}

/PBSSCE/{
	ind1 ++ ;
	x[ind1] = -$5 ;
	if(x[ind1] >= 3500)
		x[ind1] = 200.00 ;
}

/Maximum current/{
	ind2 ++ ;
	y[ind2] = -$4 ;
}

END{
	if(ind1 != ind2){
		printf("Error: %d != %d\n", ind1, ind2) ;
	}else {
		printf("______________________________\n") ;
		printf("\tSSC1\tSSC2\tDiff.\n") ;
		printf("______________________________\n") ;
		for(i=1;i<=ind1;i++){
			if(y[i] > 0) error = (x[i]-y[i])*100/(y[i]) ;
			printf("Grp%d\t%.2lf\t%.2lf\t%.2lf%%\n", i, y[i], x[i], error) ;
			if(error > 0)
				total_error += error
			else 
				total_error += -error
			total_current += y[i] ;
			if(y[i] < lest_current)
				lest_current = y[i] ;
		}
		printf("______________________________\n") ;
		printf("Average error\t%.2lf%%\n", total_error/ind1) ;

		total1 = total2 = 0 ;
		printf("a=[") ;
		for(i=1;i<=ind1;i++){
			if(i != ind1)
				printf("%.2lf, ", x[i]) ;
			else 
				printf("%.2lf];\n", x[i]) ;
			total1 += x[i] ;
		}
		printf("b=[") ;
		for(i=1;i<=ind1;i++){
			if(i != ind1)
				printf("%.2lf, ", y[i]) ;
			else 
				printf("%.2lf];\n", y[i]) ;
			total2 += y[i] ;
		}
		printf("u=[0, 1400] ;\nv=[0, 1400] \nplot(a, b, '*', u, v, '-') \n") ;
		printf("xlabel('Estimation') ;\n") ;
		printf("ylabel('GA') ;\n") ;
		printf("Average SSC1= %.2lf, SSC2= %.2lf\n", total1/ind1, total2/ind2) ; 
	}
}
