BEGIN{
	ga_time = 0 ;
	gr_number = 0 ;
	ue_time = 0 ;
	rs_time = 0 ;
	pre_time = 0 ;
	n_ga = 0 ;
	n_ue = 0 ;
	n_rs = 0 ;
}

/Group Numbers/{
	split($2, a, ":") ;
	gr_number = a[2] ;
}

/GA time/{
	split($2, a, ":") ;
	ga_time += a[3] ;
	n_ga ++ ;
}

/random simulation 100 time/{
	split($4, a, ":") ;
	rs_time = a[2] ;
}

/EStimate_current_/{
	split($1, a, ":") ;
	ue_time += a[2] ;
	n_ue ++ ;
}

/ASB Preparation/{
	print $2 ;
	split($2, a, ":") ;
	pre_time = a[2] ;
}

END{
	n_ue = n_ue /2 ;
	#printf("Rs %.2lf, GA %.2lf, UE %.2lf\n", rs_time*500/60, ga_time/n_ga, ue_time/n_ue) ;
	printf("GA %.2lf, UE %.2lf\n", ga_time/n_ga, ue_time/n_ue) ;
	#printf("Pre: %.2lf\n", pre_time) ;
}
