BEGIN{
	loc = -1	
}

/Group Numbers/{
	loc ++ ;
	ind = 1 ;
}

/Generation=49/{
	split($3, x, "=") ;
	if(loc == 0){
		a[ind] = x[2] ;
		ind ++ ;
	}else if(loc == 1){
		b[ind] = x[2] ;
		ind ++ ;
	}
}

/Entering into/{
	ind = 1 ;	
}

/Cluster current/{
        c[ind] = $4 ;
        ind ++ ;
}


END{
	for(i=1;i<ind-1;i++){
	for(j=i+1;j<ind;j++){
		if(a[i] > a[j]){
			t=a[i] ;
			a[i]=a[j] ;
			a[j]=t ;
	
			t=b[i] ;
			b[i]=b[j] ;
			b[j]=t ;

			t=c[i] ;
			c[i]=c[j] ;
			c[j]=t ;
		}
	}
	}

	printf("a=[") ;
	for(i=1;i<ind;i++){
		printf("%.2f", a[i]) ;
		if(i == ind-1)
			printf("];\n") ;
		else 
			printf(",") ;
	}
	printf("b=[") ;
	for(i=1;i<ind;i++){
		printf("%.2f", b[i]-10000) ;
		if(i == ind-1)
			printf("];\n") ;
		else 
			printf(",") ;
	}
	printf("c=[") ;
	for(i=1;i<ind;i++){
		printf("%.2f", c[i]) ;
		if(i == ind-1)
			printf("];\n") ;
		else 
			printf(",") ;
	}
	printf("x=[") ;
	for(i=1;i<ind;i++){
		printf("%.2f", i) ;
		if(i == ind-1)
			printf("];\n") ;
		else 
			printf(",") ;
	}
	printf("plot(x, a, '-d', x, b, '-^', x, c, '-v');\n")  ;
	printf("legend('Accurate', 'Localized', 'Pseudo');\n") ;
	printf("xlabel('Clusters');\n") ;
	printf("ylabel('MSSC Value(uA)');\n") ;
}
