/***************************************************************************
			FILE:       linearExt.h
			DESCR:      linear table operation (extra)
			AUTH:       Fei Li
			DATE:       Jun. 2001
***************************************************************************/
#ifndef _LINEAR_EXTRA_
#define	_LINEAR_EXTRA_

#include "linear.h"

/* get next record in the linear table 
 */
extern lin_table_rec 	next_lin_table_rec(lin_table_rec current);
extern bi_lin_table_rec next_bi_lin_table_rec(bi_lin_table_rec current);

/* lookup by content of member 
 */
extern bi_lin_table_rec	bi_lin_table_lookup_by_member(bi_lin_table_rec head, pointer pMember);
extern lin_table_rec	lin_table_rec_lookup_by_member(lin_table_rec head, pointer pMember, lin_table_rec *preRec);

/* stack transfer */
void stackTransfer(stk_rec *head1, stk_rec *head2);

/* get next record in a stack 
 */
#define NEXT_STK_REC(CURR) \
		next_lin_table_rec(CURR)

#endif
