#include "PWcir.h"
#include "linearExt.h"

#include "PWglobal_var.h"
#include "PWroutines.h"

extern	void	report_gain(void);
extern  void	report_imply_stk_top(void);

/* for Imax/Gain algorithm */
/* assign the initial gain to all gates */
void
PWgateInitGain_gain()
{
	int		i;
	stk_rec	trackGateList=NULL;

	initImplyStk();

	for(i=0;i<PWinstNum;i++)
	{
		if(instList[i].instLibNo!=PO_LIB_NO &&
		   instList[i].instLibNo!=DF_LIB_NO &&
		   instList[i].instLibNo!=DFR_LIB_NO &&
           instList[i].instLibNo!=DFS_LIB_NO &&
           instList[i].instLibNo!=DFRS_LIB_NO)

		{
			/* for real gates and PI,we have gain metrc.*/ 

			/* initialize gate gain under current situation */
			/* gain bucket has not been established,
			   so the return value and trackGateList is ignored
			*/
			if(fetchImplyValueInStk(&(instList[i])) == VALUE_UNKNOWN)
			{
				updtGateGain(&(instList[i]),TRUE,&trackGateList);
				if(trackGateList!=NULL)
				{
					fprintf(stderr,"Error in PWgate InitGain().\n");
					exit(1);
				}
			}
		}
	}
	/* for debugging */
	/*
	report_gain();
	*/
	/*report_imply_stk_top();*/
}
